#!/bin/bash

set -ue

source ./config.ini

# 更改 NODE 标签
function node_labels() {
    nodes=$( docker node ls  | awk 'NR!=1{print $1}')
    n=0
    for node_id in ${nodes[@]}
    do
        node_ip=$(docker node inspect --format '{{if eq "0.0.0.0" .Status.Addr}}{{.ManagerStatus.Addr}}{{else}}{{.Status.Addr}}{{end}}' ${node_id}|awk -F':' '{print $1}')
        # 判断中间件节点IP是否存在,如果存在，则更新节点标签
        if [[ "${midd_ip_list[@]}"  =~ (^|[[:space:]])"$node_ip"($|[[:space:]]) ]]; then
            log info "$node_id 节点IP: $node_ip"
            log info "更新 $node_ip 标签 mysql$n"
            docker node update --label-add mysqllabels=mysql"$n" $node_id
            let n=$n+1
            log info "更新 $node_ip 标签 redis$n"
            docker node update --label-add redislabels=redis"$n" $node_id
            log info "更新 $node_ip 标签 rabbitmq$n"
            docker node update --label-add rabbitmqlabels=rabbitmq"$n" $node_id
            log info "更新 $node_ip 标签 eslabels$n"
            docker node update --label-add eslabels=es"$n" $node_id
        else
            log error "$node_ip 不存在 docker swarm 集群中."
            exit 1
        fi
    done
}

node_labels
